/**
 * @(#)file    SheetTDUtil.java
 * @(#)author  [개발자명]
 * @(#)version 1.0
 * @(#)date    May 10, 2007
 * @(#)since   JDK 1.4.2
 *
 * Copyright (c) www.hwenc.co.kr, Inc.
 * All rights reserved.
 * This software is the proprietary information of Hanwha E&C, Inc.
 */
package kr.co.udapsoft.common.sheet;

import kr.co.udapsoft.common.sheet.SheetTD;

public class SheetTDUtil {

	private SheetTDUtil() {
	}

	/**
	 * SheetTD.isBlankValue 값을 Array 구간으로 세팅
	 * @param sheetTDs
	 * @param isBlankValue
	 * @param startIndex
	 * @param endIndex
	 */
	public static void setIsBlankValue(SheetTD[] sheetTDs, boolean isBlankValue, int startIndex, int endIndex) {
		for( int i = startIndex ; i < endIndex ; i++ ) {
			sheetTDs[i].isBlankValue = isBlankValue;
		}
	}

	/**
	 * SheetTD.rowSetColumnIndex 값을 Array 구간으로 세팅
	 * @param sheetTDs
	 * @param startColumnIndex
	 * @param startIndex
	 * @param endIndex
	 */
	public static void setRowSetColumnIndex(SheetTD[] sheetTDs, int startColumnIndex, int startIndex, int endIndex) {
		for( int i = startIndex ; i < endIndex ; i++ ) {
			sheetTDs[i].rowSetColumnIndex = startColumnIndex++;
		}
	}

	/**
	 * SheetTD.rowSetKey 값을 Array 구간으로 세팅
	 * @param sheetTDs
	 * @param rowSetKey
	 * @param startIndex
	 * @param endIndex
	 */
	public static void setRowSetKey(SheetTD[] sheetTDs, String rowSetKey, int startIndex, int endIndex) {
		for( int i = startIndex ; i < endIndex ; i++ ) {
			sheetTDs[i].rowSetKey = rowSetKey;
		}
	}

	/**
	 * SheetTD.Attribute 값을 Array 구간으로 세팅
	 * @param sheetTDs
	 * @param key
	 * @param value
	 * @param startIndex
	 * @param endIndex
	 */
	public static void setAttribute(SheetTD[] sheetTDs, String key, String value, int startIndex, int endIndex) {
		for( int i = startIndex ; i < endIndex ; i++ ) {
			sheetTDs[i].setAttribute(key, value);
		}
	}
}
