/**
 *
 * @(#)author  [ok]
 * @(#)version 1.0
 * @(#)date    2014. 06. 30
 * @(#)since   JDK 1.7.2
 *
 * Copyright (c) www.udapsoft.co.kr, Inc.
 * All rights reserved.
 * This software is the proprietary information of udapsoft, Inc.
 */
 package kr.co.udapsoft.ebid.buyer.portal.payment.biz;


import kr.co.hsnc.common.base.WAFLogger;
import kr.co.hsnc.common.sql.RowSet;
import kr.co.hsnc.common.sql.RowSetImpl;
import kr.co.hsnc.common.sql.search.Search;
import kr.co.hsnc.common.sql.search.SearchImpl;
import kr.co.hsnc.common.util.ValueObject;

import com.udapsoft.modular.web.ibsheet7.IBSheet7Factory;
import com.udapsoft.waf.system.Biz;
import com.udapsoft.waf.system.HandlerStorage;

public class ResolutionRequestListViewBiz extends Biz {
	
	public ResolutionRequestListViewBiz(HandlerStorage storage) {
		super(storage);
	}

	public void doBiz() throws Exception {

		WAFLogger.debug("협력업체포탈 기성신청현황 리스트 데이터 조회");
		
		if(storage.compareEvent("GET_DATA")){	//데이터 조회
			params.set("sheet1", getPrePaymentList(params));
			storage.addObject("ibsheet7Data", IBSheet7Factory.createIBSheet7(params, storage.request));
		}
	}

    /**
     *@param ValueObject
     *@return RowSet
     *기   능 : 기성신청현황 데이터 조회
     *@author OK
     *@version 2014. 6. 30.
     *@since JDK1.7
     */
    public RowSet getPrePaymentList(ValueObject Params) {
        Search search = new SearchImpl();
        RowSet listRowSet = null;
        String sqlstr = "";
        
        try {
        	sqlstr += " SELECT A.SUB_CONT_ID 			  								  								\n"
        			+ "       , A.BUILD_NAME					               			  								\n"
        			+ "       , TO_CHAR(A.START_WORK_DATE ,'YYYY-MM-DD')||' ~ ' || TO_CHAR(A.END_WORK_DATE ,'YYYY-MM-DD') AS START_END_WORK_DATE 		            \n"
        			+ "       , A.CON_AMT          --계약금액					   			     	                        \n"
        			+ "       , A.CON_SUPPLY_AMT   --계약공급가					             	                        \n"
        			+ "       , A.CON_SUPPLY_TAMT  --계약공급가_과세				                 	                    \n"
        			+ "       , A.CON_SUPPLY_NAMT  --계약공급가_면세						                                \n"
        			+ "       , A.CON_SURTAX_AMT   --계약부가세							                                \n"
        			+ "       , NVL(C.ACMP_NO, '1') AS ACMP_NO							                                \n"
        			+ "       , NVL(C.FUND_AMT, 0) AS FUND_AMT           --금회기성			                    		\n"
        			+ "       , NVL(C.TOT_FUND_AMT, 0)  AS TOT_FUND_AMT  --누계기성		                                \n"
        			+ "       , A.CON_AMT - NVL(C.TOT_FUND_AMT, 0) AS MOD_FUND_AMT    --잔여기성                             \n"
        			+ "       , ROUND((NVL(C.TOT_FUND_AMT, 0) /A.CON_SUPPLY_AMT)*100,1) FUND_RATE  --기성율                \n"
        			+ "       , A.CON_CLS_YN     --상태							            	                        \n"
        			+ "       , TO_CHAR(TO_DATE(C.ACMP_YYYYMM,'YYYYMM'),'YYYY-MM')  AS ACMP_YYYYMM --기성년월              \n"
        			+ "       , C.ACMP_ID    	 --기성차수 								                            	\n"
        			+ "       , C.STATUS_CD       --상태	 								                            	\n"
        			+ "       , C.CON_CORP_ID     --계약업체ID							                            	\n"
        			+ " FROM (SELECT A.*														                        \n"
        			+ " 	  FROM SUB1000T!CCSIF A,											                        \n"
        			+ " 	  		(SELECT MAX(SUB_CONT_ID) AS SUB_CONT_ID				         		                \n"
        			+ "   			 FROM SUB1000T!CCSIF A										                        \n"
        			+ " 			 GROUP BY  CON_DOC_NO) AA									                        \n"
        			+ " 	  WHERE A.SUB_CONT_ID = AA.SUB_CONT_ID								                        \n"
        			+ " 	  ) A,																                        \n"
        			/**
        			 * 2018.11.23
        			 * 이인오
        			 * 안쓰는소스 경영정보 디비링크 삭제
        			 */
        			+ " 	  SUB1020T!CCSIF B,													                        \n"
        			+ " 	  SUB1040T!CCSIF C													                        \n"
        			+ " WHERE 1=1																                        \n"
        			+ " AND A.SUB_CONT_ID = B.SUB_CONT_ID										                        \n"
        			+ " AND B.CON_CORP_ID = C.CON_CORP_ID(+)									                        \n";
        	
        	if(!"".equals(params.get("buildName"))){
        		sqlstr += " AND UPPER(A.BUILD_NAME) LIKE UPPER('%" + params.get("buildName") + "%')						\n";
        	}
        	if(!"".equals(params.get("searchDate"))){
        		sqlstr += " AND C.ACMP_YYYYMM = '"+Params.get("searchDate").replaceAll("-", "")+"'											\n";
        	}
        	if(!"".equals(params.get("detailcd"))){
        		sqlstr += " AND C.STATUS_CD = '"+Params.get("detailcd")+"'												\n";
        	}
            
            sqlstr += " ORDER BY A.SUB_CONT_ID  																		\n"; 
            search.setStatement(sqlstr);
            WAFLogger.debug(sqlstr);
            listRowSet = search.execute();
           
        }
        catch(Exception e) {
            WAFLogger.error(this.getClass().getName() + " --> getPrePaymentList() : " + e.getMessage());
            WAFLogger.error("SQL : " + search.getStatement());
            WAFLogger.error(e);
            return null;
        }
        finally {

            if( listRowSet == null ) listRowSet = new RowSetImpl();
            return listRowSet;
        }
    }
}
