/**
 * @(#)file    ContIntBiz.java
 * @(#)author  Kim Myung Ho
 * @(#)version 1.0
 * @(#)date    2014-09-04
 * @(#)since   JDK 1.4.2
 */
package kr.co.udapsoft.ebid.supplier.portal.cont.biz;


import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.ArrayList;

import oracle.toplink.internal.ox.StrBuffer;
import kr.co.hsnc.common.base.WAFLogger;
import kr.co.hsnc.common.config.WAFConfig;
import kr.co.hsnc.common.sql.Row;
import kr.co.hsnc.common.sql.RowSet;
import kr.co.hsnc.common.sql.RowSetImpl;
import kr.co.hsnc.common.sql.WAFSQLException;
import kr.co.hsnc.common.sql.persistent.Persistent;
import kr.co.hsnc.common.sql.persistent.PersistentImpl;
import kr.co.hsnc.common.sql.search.Search;
import kr.co.hsnc.common.sql.search.SearchImpl;
import kr.co.hsnc.common.sql.util.RowSetUtility;
import kr.co.hsnc.common.util.ValueObject;
import kr.co.udapsoft.common.code.CommCodeManager;
import kr.co.udapsoft.common.util.Crosscert;
import kr.co.udapsoft.common.util.PDFMaker;
import kr.co.udapsoft.ebid.buyer.common.file.FileManager;
import kr.co.udapsoft.ebid.buyer.sycs.user.biz.UserCommon;

import com.udapsoft.modular.web.ibsheet7.IBSheet7Factory;
import com.udapsoft.modular.web.ibsheet7.util.IBSheet7Utils;
import com.udapsoft.waf.common.ui.InitCombo;
import com.udapsoft.waf.common.util.StringUtils;
import com.udapsoft.waf.system.Biz;
import com.udapsoft.waf.system.HandlerStorage;

   
public class PurPayGuarSearchBiz extends Biz {

	public PurPayGuarSearchBiz(HandlerStorage storage) {
		super(storage);
	}

	public void doBiz() throws Exception {
        ValueObject user = new ValueObject();

		boolean success = false;
		
		if(storage.compareEvent("")){
			
		}else if(storage.compareEvent("SHEET_SELECT")){
			params.set("sheet1", getContList(params));
			
			storage.addObject("ibsheet7Data", IBSheet7Factory.createIBSheet7(params, storage.request));			
		}else if(storage.compareEvent("SHEET_WARR")){
			params.set("sheet2", getWarrList(params));
			
			storage.addObject("ibsheet7Data", IBSheet7Factory.createIBSheet7(params, storage.request));
		}		
	}

	/**
	 * 하도급 대금 지급 대상 계약 리스트 조회
	 * @param Params
	 * @return
	 */
	private RowSet getContList(ValueObject param) {

		Search search = new SearchImpl();
        RowSet rowSet = new RowSetImpl();
        ValueObject user = storage.getUser();
     //   String sqlstr = "";
        StrBuffer sqlstr = new StrBuffer();
        try{
        	sqlstr.append(" 	SELECT A.PUR_CONT_MOD_ID			                                                                                        \n");
        	sqlstr.append(" 	     ,(A.ORD_DOC_NO || '-' || A.MOD_NO) AS CON_DOC_NO	                                                                    \n");
        	sqlstr.append(" 	     ,A.MOD_NO						                                                                                        \n");
        	sqlstr.append(" 	     ,A.PUR_CONT_ID					                                                                                        \n");
        	sqlstr.append(" 	     ,A.DEPT_NAME					                                                                                        \n");
        	sqlstr.append(" 	     ,A.CST_DOC_NAME BUILD_NAME					                                                                                        \n");
        	sqlstr.append(" 	     ,TO_CHAR(A.ORD_CON_DATE, 'YYYY-MM-DD') AS CON_DATE	                                                                        \n");
        	sqlstr.append(" 	     ,F.MEMBER_NAME					                                                                                        \n");
        	sqlstr.append(" 	     ,TO_CHAR(A.ORD_AMT, '999,999,999,999,999') AS CON_AMT	                                                                \n");
        	sqlstr.append(" 	     ,TO_CHAR(A.ORD_START_DATE, 'YYYY-MM-DD') || '~' || TO_CHAR(A.ORD_END_DATE, 'YYYY-MM-DD') AS WORK_START_END_DATE	    \n");
        	sqlstr.append(" 	     ,A.ORD_START_DATE START_WORK_DATE				                                                                                        \n");
        	sqlstr.append(" 	     ,A.ORD_END_DATE END_WORK_DATE				                                                                                        \n");
        	sqlstr.append(" 	     ,A.CON_GB 						                                                                                        \n");
        	sqlstr.append(" 	     ,A.STATUS_CD 					                                                                                        \n");
        	sqlstr.append(" 	     ,F_GET_CODE_NAME('MOD_GB',NVL(DECODE(A.MOD_GB,'1','01','2','10','3','11','9','99', A.MOD_GB),'00')) AS CAUSECODE_NM 	\n");        	
        	sqlstr.append(" 	  FROM PUR2000T A, CONT_PUR_WARR B, CONT_PUR_SUPP F	                                                            \n");  //2016.11.14 변경계약도 포함
        	sqlstr.append("   WHERE 1=1								                                                                                        \n");
    		sqlstr.append("   	AND A.PUR_CONT_MOD_ID = F.PUR_CONT_MOD_ID			                                                                        \n");
    		sqlstr.append("   	AND A.PUR_CONT_MOD_ID = B.PUR_CONT_MOD_ID(+)		                                                                        \n");    		
    		sqlstr.append("   	AND A.CON_CLS_YN = 9				                                                                                        \n");
    		sqlstr.append("   	AND F.SIGN_SEQ = 2					                                                                                        \n");
    		sqlstr.append("   	AND F.CORP_ID = "+ user.get("CORP_ID") +"			\n"); //2015.9.17추가 
    		sqlstr.append("   	AND B.WARR_GUBUN = '2'                     			\n"); //2015.9.17보증서 등록된 계약만 조회.
        	// 현장
        	if(!param.get("P_DEPT_CD").isEmpty()) {
        		sqlstr.append(" AND A.DEPT_CD = ?																												 \n");
    			search.addParameter(params.get("P_DEPT_CD"));
        	}
        	if(!param.get("P_BUILD_NM").isEmpty())
        		sqlstr.append("   AND A.CST_DOC_NAME LIKE '%"+param.get("P_BUILD_NM")+"%'				\n");
        	if(!param.get("ContFromDt").isEmpty())
        		sqlstr.append("   AND TO_CHAR(A.ORD_CON_DATE, 'YYYY-MM-DD') >= '"+param.get("ContFromDt")+"'				\n");
        	if(!param.get("ContToDt").isEmpty())
        		sqlstr.append("   AND TO_CHAR(A.ORD_CON_DATE, 'YYYY-MM-DD') <= '"+param.get("ContToDt")+"'				\n");
        	
        	if(!param.get("p_dealer_nm").isEmpty())
        		sqlstr.append("   AND F.MEMBER_NAME LIKE '%'|| '"+param.get("p_dealer_nm")+"' ||'%'	\n");
        	
        	sqlstr.append("   ORDER BY A.ORD_CON_DATE DESC	\n"); 
        	search.setStatement(sqlstr.toString());
        	System.out.println(sqlstr.toString());
            rowSet = search.execute();
        }
        catch (WAFSQLException se) {
            super.doException(se);
            this.storage.setSuccess(false);  
            this.storage.setMessage(se.getMessage());
            storage.setDetailMessage(se);
        }
        finally {    
            if(rowSet == null){
            	rowSet = new RowSetImpl();
            }
        }
        return rowSet;
	}
	
	/**
	 * 보증 대상리스트 조회
	 * @param Params
	 * @return
	 */
	private RowSet getWarrList(ValueObject param) {

		Search search = new SearchImpl();
        RowSet rowSet = new RowSetImpl();
        
     //   String sqlstr = "";
        /*
		보증서 종류
		  002 : 계약이행
		  003 : 하자
		  004 : 선금
		  005 : 근로자재해
		  39 : 하도급대금지급         * 
         * */
        StrBuffer sqlstr = new StrBuffer();
        try{
        	sqlstr.append("	SELECT  NVL(MAX(WARR_GUBUN),'2') AS WARR_GUBUN	\n");
        	sqlstr.append("	    , NVL(MAX(WARR_GUBUN_NM),'하도급대금지급보증') AS WARR_GUBUN_NM	\n");
        	sqlstr.append("	    , NVL(MAX(WARR_SEQ), (SELECT NVL(MAX(WARR_SEQ),0) + 1 FROM CONT_PUR_WARR WHERE PUR_CONT_MOD_ID = '"+ params.get("PUR_CONT_MOD_ID") +"')) AS WARR_SEQ	\n");
        	sqlstr.append("	    , TO_CHAR(MAX(WARR_WAMT), '999,999,999,999,999') AS WARR_WAMT	\n");
        	sqlstr.append("	    , TO_CHAR(MAX(WARR_COMMSN), '999,999,999,999,999') AS WARR_COMMSN 	\n");
        	sqlstr.append("	    , NVL(MAX(VIEW_DIV),'SUBCONPAY') AS VIEW_DIV	\n");
        	sqlstr.append("	    , NVL(CAUSECODE,'01') AS CAUSECODE	\n");
        	sqlstr.append("	    , F_GET_CODE_NAME('CAUSECODE',NVL(CAUSECODE,'01')) AS CAUSECODE_NM	\n");
        	sqlstr.append("	    , NVL(MAX(WARR_GOFFICE),'건설공제조합') AS WARR_GOFFICE	\n");  //건설공제조합 2016.5.11수정 
        	sqlstr.append("	    , MAX(GUAR_STATUS) AS GUAR_STATUS	\n");
        	sqlstr.append("	    , F_GET_CODE_NAME('GUAR_STATUS',NVL(MAX(GUAR_STATUS),'01')) AS GUAR_STATUS_NM	\n");
        	sqlstr.append("	    , MAX(PAPERDATE) AS PAPERDATE	\n");
        	sqlstr.append("	    , MAX(WARR_WGNO) AS WARR_WGNO	\n");
        	sqlstr.append("	    , MAX(WARR_SDATE) AS WARR_SDATE	\n");
        	sqlstr.append("	    , MAX(WARR_EDATE) AS WARR_EDATE	\n");
        	sqlstr.append("	    , MAX(WARR_START_END_DATE) AS WARR_START_END_DATE	\n");
        	sqlstr.append("	    , MAX(GRTREQNO) AS GRTREQNO 	\n");
        	sqlstr.append("	    , MAX(GUAR_ONOFF_YN) AS GUAR_ONOFF_YN 	\n");
        	sqlstr.append("	    , MAX(WARR_GREM) AS WARR_GREM 	\n");
        	sqlstr.append(" 	, DECODE(MAX(GUAR_ONOFF_YN), NULL, 0, DECODE(MAX(GUAR_STATUS), '08', 2, '09', 2, 1)) AS BTN 	\n");
        	sqlstr.append("	    , MAX(WARR_GOFFICE_ID) AS WARR_GOFFICE_ID	\n");
        	sqlstr.append("	     FROM (	\n");

        	sqlstr.append("	              SELECT WARR_GUBUN	\n");
        	sqlstr.append("	                   , F_GET_CODE_NAME('GAUR_KIND',WARR_GUBUN) AS WARR_GUBUN_NM	\n");
        	sqlstr.append("	                   , WARR_SEQ	\n");
        	sqlstr.append("	                   , NVL(WARR_WAMT, 0) AS WARR_WAMT	\n");
        	sqlstr.append("	                   , NVL(WARR_COMMSN, 0) AS WARR_COMMSN	\n");
        	sqlstr.append("	                   , VIEW_DIV	\n");
        	sqlstr.append("	                   , CAUSECODE	\n");
        	sqlstr.append("	                   , WARR_GOFFICE	\n");
        	sqlstr.append("	                   , GUAR_STATUS	\n");
        	sqlstr.append("	                   , TO_CHAR(TO_DATE(PAPERDATE),'YYYY-MM-DD') AS PAPERDATE	\n");
        	sqlstr.append("	                   , WARR_WGNO	\n");
        	sqlstr.append("	                   , WARR_SDATE	\n");
        	sqlstr.append("	                   , WARR_EDATE 	\n");
        	sqlstr.append("	                   , (TO_CHAR(TO_DATE(WARR_SDATE),'YYYY-MM-DD') || '~' || TO_CHAR(TO_DATE(WARR_EDATE),'YYYY-MM-DD')) AS WARR_START_END_DATE 	\n");
        	sqlstr.append("	                   , GRTREQNO 	\n");
        	sqlstr.append("	                   , GUAR_ONOFF_YN	\n");
        	sqlstr.append("	                   , WARR_GREM 	\n");
        	sqlstr.append("	                   , F_GET_CODE_NAME('GUAROFFICEID',GUAR_ORGAN_CODE) AS WARR_GOFFICE_ID	\n");
        	sqlstr.append("	                FROM CONT_PUR_WARR 	\n");
        	sqlstr.append("	               WHERE PUR_CONT_MOD_ID = '"+ param.get("PUR_CONT_MOD_ID") +"' 	\n");
        	sqlstr.append("	                     AND WARR_GUBUN IN ('2')	\n");
        	sqlstr.append("		\n");
        	sqlstr.append("	              UNION ALL	\n");
        	sqlstr.append("		\n");
        	sqlstr.append("	              SELECT null AS WARR_GUBUN	\n");
        	sqlstr.append("	                   , null AS WARR_GUBUN_NM	\n");
        	sqlstr.append("	                   , NULL AS WARR_SEQ	\n");
        	sqlstr.append("	                   , 0 AS WARR_WAMT	\n");
        	sqlstr.append("	                   , 0 AS WARR_COMMSN	\n");
        	sqlstr.append("	                   , null AS VIEW_DIV	\n");
        	sqlstr.append("	                   , NVL(DECODE(MOD_GB,'1','03','2','02','3','04'),'01') AS CAUSECODE	\n");
        	sqlstr.append("	                   , null AS WARR_GOFFICE	\n");
        	sqlstr.append("	                   , '' AS GUAR_STATUS	\n");
        	sqlstr.append("	                   , '' AS PAPERDATE	\n");
        	sqlstr.append("	                   , '' AS WARR_WGNO	\n");
        	sqlstr.append("	                   , '' AS WARR_SDATE	\n");
        	sqlstr.append("	                   , '' AS WARR_EDATE 	\n");
        	sqlstr.append("	                   , '' AS WARR_START_END_DATE 	\n");
        	sqlstr.append("	                   , '' AS GRTREQNO 	\n");
        	sqlstr.append("	                   , '' AS GUAR_ONOFF_YN 	\n");
        	sqlstr.append("	                   , '' AS WARR_GREM 	\n");
        	sqlstr.append("	                   , '' AS WARR_GOFFICE_ID 	\n");
        	sqlstr.append("	                FROM DUAL A, PUR2000T B 	\n");
        	sqlstr.append("	               WHERE B.PUR_CONT_MOD_ID = '"+ param.get("PUR_CONT_MOD_ID") +"' 	\n");
        	sqlstr.append("	                     AND  (SELECT COUNT(*) FROM CONT_PUR_WARR W WHERE  W.PUR_CONT_MOD_ID = B.PUR_CONT_MOD_ID AND W.WARR_GUBUN = 2)  = 0 	\n");
        	sqlstr.append("	                     AND B.ORD_AMT > 10000000	\n");
//        	sqlstr.append("	                     AND SUBSTR(MOD_GB,1,1) !=0	\n");
        	sqlstr.append("	                	\n");
        	sqlstr.append("	     )	\n");
        	sqlstr.append("	GROUP BY  WARR_SEQ, CAUSECODE	\n");
        	sqlstr.append("	ORDER BY  WARR_GUBUN	\n");
			search.setStatement(sqlstr.toString());
            rowSet = search.execute();
        }
        catch (WAFSQLException se) {
            super.doException(se);
            this.storage.setSuccess(false);  
            this.storage.setMessage(se.getMessage());
            storage.setDetailMessage(se);
        }
        finally {    
            if(rowSet == null){
            	rowSet = new RowSetImpl();
            }
        }
        return rowSet;
	}	
}