/**
 * @(#)file    TermsAgreeBiz.java
 * @(#)author  이성민
 * @(#)version 1.0
 *
 */
package kr.co.udapsoft.ebid.supplier.portal.result.biz;



import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.text.SimpleDateFormat;
import java.util.Calendar;

import org.jdom.Document;
import org.jdom.Element;
import org.jdom.output.Format;
import org.jdom.output.XMLOutputter;

import kr.co.hsnc.common.base.WAFLogger;
import kr.co.hsnc.common.sql.Row;
import kr.co.hsnc.common.sql.RowSet;
import kr.co.hsnc.common.sql.RowSetImpl;
import kr.co.hsnc.common.sql.WAFSQLException;
import kr.co.hsnc.common.sql.persistent.Persistent;
import kr.co.hsnc.common.sql.persistent.PersistentImpl;
import kr.co.hsnc.common.sql.search.Search;
import kr.co.hsnc.common.sql.search.SearchImpl;
import kr.co.hsnc.common.sql.util.RowSetUtility;
import kr.co.hsnc.common.util.ValueObject;
import kr.co.udapsoft.ebid.buyer.common.file.FileManager;

import com.udapsoft.modular.web.ibsheet7.IBSheet7Factory;
import com.udapsoft.modular.web.ibsheet7.util.IBSheet7Utils;
import com.udapsoft.waf.system.Biz;
import com.udapsoft.waf.system.HandlerStorage;






public class ResultFinishListBiz extends Biz {

	public ResultFinishListBiz(HandlerStorage storage) 
	{
		super(storage);
	}

	/* (non-Javadoc)
	 * @see kr.co.hwenc.system.Biz#doBiz()
	 */
	public void doBiz() throws Exception 
	{
	    //System.out.println(":::::::::::::::::::::::::::::::::::::::::::::::::::::::ResultFinishListBiz::::::::::::::::::::::::::::::::::::::::::::::::::::::::" + storage.getEvent());
	    //System.out.println(storage.getUser());
	    
	    if(storage.compareEvent("GET_END_LIST"))
        {
	        
	        
	        if(params.get("acmp_yyyy").equals(""))
	        {
	            Calendar cal = Calendar.getInstance();
	            cal.add(cal.YEAR,-1);
	            
	            String yyyy = (new java.text.SimpleDateFormat ("yyyy")).format (cal.getTime());
	            params.set("acmp_yyyy", yyyy);
	        }
	        
	        
            params.set("sheet1", getResultFinishList(params));
            storage.addObject("ibsheet7Data", IBSheet7Factory.createIBSheet7(params, storage.request));
        }
	    
	}
	
	
	private RowSet getResultFinishList(ValueObject Params) {
        Search search = new SearchImpl();
        RowSet rowSet = new RowSetImpl();
        StringBuffer sqlStr = new StringBuffer();
        
        try {
            sqlStr.append("            SELECT SUB_CONT_MOD_ID -- 외주계약변경ID                                                \n")
                   .append("                         ,ACMP_YYYY -- 기성년도                                                \n")
                   .append("                         ,DEPT_CD -- 현장코드                                                \n")
                   .append("                         ,GET_DEPT_NM(DEPT_CD) DEPT_NAME -- 현장명                                                \n")
                   .append("                         ,CORP_ID                                                \n")
                   .append("                        ,ISU_VENDCD -- 신청인발급요청자) 사업자번호                                                 \n")
                   .append("                        ,ISU_VENDNM -- 신청인(발급요청자) 상호                                                \n")
                   .append("                        ,ISU_PRES_NM -- 신청인(발급요청자) 대표자명                                                \n")
                   .append("                        ,ISU_ADDR -- 신청인(발급요청자) 주소                                                \n")
                   .append("                        ,ISU_PHONE -- 신청인(발급요청자) 전화번호                                                \n")
                   .append("                        ,CONT_NM -- 공종(계약)명                                                \n")
                   .append("                        ,WORK_PLACE -- 현장소재지 (공사현장)                                                \n")
                   .append("                        ,CON_AMT -- 공종(계약)금액                                                \n")
                   .append("                        ,CONT_CDATE -- 계약년월일 (YYYYMMDD)                                                \n")
                   .append("                        ,CONT_SDATE -- 착공년월일 (YYYYMMDD)                                                \n")
                   .append("                        ,CONT_EDATE-- 준공년월일 (YYYYMMDD)                                                \n")
                   .append("                        ,CONT_TAMT --  총계약금액 (총공사금액)                                                \n")
                   .append("                        ,CUR_PAY_AMT -- 당년도 기성액                                                \n")
                   .append("                        ,ORD_NM -- 발주자                                                \n")
                   .append("                        ,CUR_CONT_AMT -- 당년도 계약액 (이월액)                                                \n")
                   .append("                        ,CUR_PAY_NAMT -- 당년도 미기성액                                                \n")
                   .append("                        ,CUR_CONT_AAMT -- 당년도추가(변경)계약액                                                \n")
                   .append("                        ,PRV_PAY_AMT-- 전년도까지 누계기성액                                                \n")
                   .append("                        ,PRV_PAY_NAMT -- 전년도까지 미기성액                                                \n")
                   .append("                        ,PRV_TRANS_AMT -- 전년도이월액 or 전년도이월공사액                                                \n")
                   .append("                        ,REG_VENDNM -- 발급자 상호                                                \n")
                   .append("                        ,REG_PRES_NM -- 발급자 대표자명                                                \n")
                   .append("                        ,REG_ADDR -- 발급자 주소                                                \n")
                   .append("                        ,REG_PHONE -- 발급자 전화번호                                                \n")
                   .append("                        ,PROG_STAT_CD  -- 진행상태 코드                                                \n")
                   .append("                        ,SOC_CD  -- 제출협회 코드                                                \n")
                   .append("                        ,DECODE(SOC_CD, '01', '대한전문건설협회', '02', '대한기계설비공사협회', '03', '한국소방시설협회', '04', '한국정보통신공사협회', '한국전기공사협회') SOC_NM                         \n")
                   .append("                        ,DECODE(PROG_STAT_CD, '10', '작성중', '20', '발급요청', '30', '발급완료', '91', '반려', '작성대상') PROG_STAT_NM                                                \n")
                   .append("             FROM RESULT_PLOOF_INFO          \n")
                   .append("             WHERE  PROG_STAT_CD = '30'          \n")
                   .append("             AND CORP_ID  = ?          \n");             
           
           
           
           
                   if(!params.get("p_yyyy").trim().equals(""))
                   {
                       sqlStr.append("              AND ACMP_YYYY = ?             \n");
                   }
                   if(!params.get("p_dept_nm").trim().equals(""))
                   {
                       sqlStr.append("              AND DEPT_NM LIKE '%' || ? || '%'             \n");
                   }
                   if(!params.get("p_cont_nm").trim().equals(""))
                   {
                       sqlStr.append("              AND CONT_NM LIKE '%' || ? || '%'             \n");
                   }
            
            
            search.setStatement(sqlStr.toString());
            search.addParameter(storage.getUser().get("CORP_ID"));
            
            if(!params.get("p_yyyy").trim().equals(""))
            {
                search.addParameter(params.get("p_yyyy").trim());
            }
            if(!params.get("p_dept_nm").trim().equals(""))
            {
                search.addParameter(params.get("p_dept_nm").trim());
            }
            if(!params.get("p_cont_nm").trim().equals(""))
            {
                search.addParameter(params.get("p_cont_nm").trim());
            }
            
            
            //System.out.println(sqlStr.toString());
            //System.out.println(search.getParameters());
            rowSet = search.execute();
        }
        catch (WAFSQLException se) {
            //System.out.println("getResultFinishList=========>" + se);
            super.doException(se);
            this.storage.setSuccess(false);
            this.storage.setMessage(se.getMessage());
            storage.setDetailMessage(se);
            se.printStackTrace();
        }
        finally {    
            if(rowSet == null) rowSet = new RowSetImpl();
            return rowSet;
        }
    }
    
	
}